/*
TASK:reliab
LANG:C++
 */
#include <stdio.h>
#include <stdlib.h>

typedef long long LLONG;
typedef unsigned int UINT;

#define N (1<<19)

LLONG n,h;
LLONG res[2][N];
LLONG sum[2];
LLONG cnt[2];
int cr,nx;

#define NEXT(x) (x+1)%2

void checkbin()
{
    LLONG t=1,k=n;
    while(k)
    {
	t*=2;
	k--;
	if(t>=h)
	{
	    printf("%lld\n",n-k);
	    exit(0);
	}
    }
}

// Nulirai!!!!
int solve(LLONG trn)
{
    int i;
    LLONG x;
    cr = 0; nx=NEXT(cr);
    if(n>trn) return 0;
    
    //printf("turns = %lld\n",trn);
    x=trn-n+1;
    i=0;
    if(n-1)
    {
	//printf("iter: 2\n");
	cnt[cr]=0;
	sum[cr]=0;
	while(x)
	{
	    res[cr][cnt[cr]]=x+1;
	    sum[cr]+=res[cr][cnt[cr]];
	    cnt[cr]++;
	    x--;
	}
	res[cr][cnt[cr]]=1;
	sum[cr]+=res[cr][cnt[cr]];
	cnt[cr]++;
	//printf("sum: %lld\n",sum[cr]);
    }
    else
    {
	cnt[cr]=1;
	sum[cr]=x;
    }

    for(i=2; i<n; i++)
    {
	//printf("iter: %d\n",i+1);
	cnt[nx]=0;
	sum[nx]=0;
	nx=cr;
	cr=NEXT(cr);

	x=sum[nx];
	while(x)
	{
	    res[cr][cnt[cr]]=x+1;
	    sum[cr]+=res[cr][cnt[cr]];
	    x-=res[nx][cnt[cr]];
	    cnt[cr]++;
	}
	res[cr][cnt[cr]]=1;
	sum[cr]+=res[cr][cnt[cr]];
	cnt[cr]++;
	//printf("sum: %lld\n",sum[cr]);
	if(sum[cr]>=h) return 1;
    }

    if(sum[cr]>=h) return 1;
    return 0;
}

void bsearch()
{
    LLONG b,e,m;
    b=1;e=h;
    while(e-b)
    {
	m=(e+b)/2;
	if(solve(m))
	{
	    e=m;
	}
	else
	{
	    b=m+1;
	}
    }
    printf("%lld\n",e);
}

int main()
{
    scanf("%lld %lld",&n,&h);
    checkbin();
    bsearch();
    return 0;
}

