/*
TASK:reliab
LANG:C++
*/

#include <cstdio>
#include <cmath>

const int MAXN = 40;
const int MAXT = 6000;
const long long _infinity = 10000000000ll;

int N, Z;
long long opt[MAXN][MAXT];

int bsrch (int row, int x) {
	int l = -1, r = MAXT, m;

    while (l + 1 < r) {
    	m = (l + r) / 2;
        if (x > opt[row][m])
        	l = m;
        else
        	r = m;
    }
    return r;
}

int main () {
	scanf ("%d%d", &N, &Z);

    int i,j;

    for (i = 0; i < MAXT; ++i)
    	opt[0][i] = i+1;

    for (i = 1; i < MAXN; ++i) {
    	opt[i][0] = 1;
    	for (j = 1; j < MAXT; ++j) {
        	opt[i][j] = opt[i][j-1] + opt[i-1][j-1] + 1;
        	if (opt[i][j] > 9999999999ll) {//soon it is going to overflow
                for (; j < MAXT; ++j)
                	opt[i][j] = _infinity;
                break;
            }
        }
    }

/*    for (i = 0; i < MAXT; ++i)
    	printf ("%lld ", opt[2][i]);
    printf  ("\n");
*/
    if (N == 2) {
        double ans = (-1 + sqrt (1 + 8 * Z)) / 2;
        printf ("%d\n", int(ceil(ans)));
    } else if (N == 1) {
        printf ("%d\n", Z);
    } else if (N <= 40) {
    	int x = bsrch (N-1, Z);
        printf ("%d\n", x+1);
    } else { //N is very big
        int x = bsrch (39, Z);//row 29 is with the 2^x
        printf ("%d\n", x+1);
    }

	return 0;
}
/*    for (i = 0; i < N; ++i) {
    	for (j = 0; j < T; ++j)
        	printf ("%lld\t", opt[i][j]);
        printf ("\n");
    }
*/

