/*
TASK:oper
LANG:C
*/

#include<stdio.h>

#define MAXK 100
#define MAXN 32

int A[MAXK][MAXK];
int Q[MAXN][MAXN];
int R[MAXN];
int razl[MAXN], l;
int k, n;

void init ()
{
   int i, j;

   for (i=0; i<=MAXN; i++)
      R[i]=1;
}

void input ()
{
   int i, j;

   scanf ("%d", &k);

   for (i=1; i<=k; i++)
      for (j=1; j<=k; j++)
         scanf ("%d", &A[i][j]);

   scanf ("%d", &n);

   for (i=1; i<=n; i++)
      scanf ("%d", &Q[1][i]);
}

void solve ()
{
   int i, j;

   for (i=1; i<n; i++)
      Q[2][i] = A[ Q[1][i] ][ Q[1][i+1] ];

   for (i=3; i<=n; i++)
      for (j=1; j<=n-i+1; j++)
         Q[i][j] = A[ Q[i-1][j] ][ Q[1][i+j-1] ];
}

void rec (int p, int s)
{
   int i, j;

   if (p == 0)
   {
      for (i=0; i<l; i++)
         if (razl[i] == s) return;
      razl[l++] = s;
   }

   for (i=1; i<=p; i++)
      rec(p-i, A[ Q[i][p-i+1] ][s]);
}

int main ()
{
   init ();
   input ();
   solve ();
   rec (n, 1);

   printf ("%d\n", l-1);

   return 0;
}
